unit Unit2;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls;

type
  TForm2 = class(TForm)
  private
    FImage: TImage;
    FLabel: TLabel;
    FBtn: TButton;
    function CreateMetafile: TMetafile;
    procedure BtnClick(Sender: TObject);
  public
    { Public declarations }
    constructor Create(aComp: TComponent); override;
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

constructor TForm2.Create(aComp: TComponent);
begin
  inherited;
  FLabel := TLabel.Create(self);
  FLabel.Parent := self;
  FLabel.Caption := 'This is a test of the emergency broadcast system';
  FLabel.Top := 10;
  FLabel.Left := 10;

  FImage := TImage.Create(self);
  FImage.Parent := self;
  FImage.Top := 30;
  FImage.Left := 10;
  FImage.Width := FLabel.Width + 10;
  FImage.Proportional := True;
  FImage.Stretch := True;
  FImage.Center := True;

  FBtn := TButton.Create(Self);
  FBtn.Parent := self;
  FBtn.Caption := 'Create Image';
  FBtn.Left := 300;
  FBtn.Top := 10;
  FBtn.OnClick := BtnClick;
end;

procedure TForm2.BtnClick(Sender: TObject);
begin
  FImage.Picture.Graphic := CreateMetafile;
  Caption := Format('Requested Size: %d x %d; Result Size: %d x %d',
    [FImage.Width, FImage.Height, FImage.Picture.Graphic.Width, FImage.Picture.Graphic.Height]);
end;

function TForm2.CreateMetafile: TMetafile;
var
  lMC: TMetafileCanvas;
begin
  Result := TMetafile.Create;

  result.Width := FImage.Width;
  result.Height := FImage.Height;
  lMC := TMetafileCanvas.Create(Result, 0);
  try
    lMC.Font := FLabel.Font;
    lMC.TextOut(1, 1, FLabel.caption);
  finally
    lMC.Free;
  end;    // try/finally
end;

end.
